Subject: bug#15839: 24.3.50; `isearch-allow-scroll': be able to scroll point off screen temporarily

From: Drew Adams <[email-masked]>
Date: Sat, 24 Nov 2018 19:14:17 -0800 (PST)

> > 2. What's more, the lazy highlighting of search hits is even more
> > limited currently.  When you scroll to the current limit, there can be
> > lots of search hits that are not highlighted.
> >
> > One of the reasons for scrolling is to see what search hits lie beyond
> > the currently shown text.  This is already partly defeated, in that
> > even when you scroll some of the hits are not highlighted.  This seems
> > more like a bug, but if the enhancement of #1 is done then it should
> > (it needs to) take care of #2 as well: Whatever text is shown should
> > have all of its search hits highlighted with lazy highlighting.
> 
> Drew, do you agree that this your request is implemented now
> with lazy-highlight-buffer, so bug#15839 could be closed?

Not as far as I understand.  That #2 is only one point (one
part) of several making up the bug report.

If scrolling forward and backward always shows all search hits
lazy-highlighted, then that one part of the bug would seem to
be fixed.

But that fixed behavior is (needs to be) anyway independent of
any customization of `lazy-highlight-buffer'.  So no, the
addition of option `lazy-highlight-buffer' in no way fixes this
bug.

Perhaps some infrastructure that has been added now provides
for a way to fix part of this bug - dunno.  By that I mean only
that now Isearch has ways of highlighting more than just a
windowful of the buffer.  Dunno whether that is helpful here.

And as I said in the bug report, even for this one part of it
(all visible search hits are not necessarily lazy-highlighted),
the lazy-highlighting needed for scrolling could be limited to
what is actually made visible by scrolling - not the whole
buffer.  Dunno whether that is a good optimization to make or
not.

What counts is the user perspective: scrolling should show all
hits highlighted, no matter how far you scroll and no matter
which directions.  And to get that behavior a user should not
need to change option `lazy-highlight-buffer'.  That option
should have no effect on this behavior, and vice versa.